#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	int n;
	cin>>n;
    int arr[n];
    for(int i = 0; i < n; i += 1){
        cin>>arr[i];
    }
    vector<pair<int,int>> ans;
    for(int i = 0; i < n; i += 1){
        int mini = arr[i];
        int posmin = i;
        for(int j = i; j < n; j += 1){
            if(arr[j] < mini){
                posmin = j;
                mini = arr[j];
            }
        }
        if(i != posmin){
            int k = arr[posmin];
            for(int j = posmin - 1; j >= i; j -= 1){
                arr[j + 1] = arr[j];
                ans.push_back({j + 1, j + 2});
            }
            arr[i] = k;
        }
    }
    cout<<ans.size()<<endl;
    for(int i = 0; i < ans.size(); i += 1){
        cout<<ans[i].first<<' '<<ans[i].second<<"\n";
    }
}
